options(java.parameters = "-Xmx16g") #16g 

library(loadeR)
library(visualizeR)

pr <- loadGridData("Documents/prlr-5km_5021_mm_monthly.nc",var="prlr")

#pr_anom <- scaleGrid(pr,clim.fun = list(FUN="mean",na.rm=T),time.frame = "monthly",type="center")

terc <- function(x){
  quantile(x,probs=0.1,na.rm=T)
}
tercile <- climatology(subsetYears(pr,years = c(1981:2010)),clim.fun = list(FUN=terc))
pr_anom <- scaleGrid(pr,base = subsetYears(pr,years = c(1981:2010)),
                     clim.fun=list(FUN="terc"),time.frame="monthly",type="center")

#spatialPlot(tercile)

pr_prueba <- pr
clim <- climatology(subsetYears(pr_prueba,1981:2010))
for(i in 1:852){
pr_prueba$Data[i,,] <- pr_prueba$Data[i,,] - redim(clim,drop=T)$Data  
}

bin <- binaryGrid(pr_anom,threshold = 0,condition = "LE")#pr_prueba
gc()
#suma_anual <- aggregateGrid(bin,aggr.y = list(FUN="sum",na.rm=T))
Barcelona <- subsetGrid(bin,lonLim = c(0,4),latLim = c(40,43))
#Barcelona_anom <- subsetGrid(pr_prueba,lonLim = c(0,3),latLim = c(40,43))

#temporalPlot(y=Barcelona_anom)

porcentual <- NA
puntos.no.na <- colMeans(Barcelona$Data,dims = 1)
puntos.no.na <- length(puntos.no.na) - length(which(is.na(puntos.no.na)))

for(i in 1:dim(bin$Data)[1]){
  porcentual[i] <- sum(Barcelona$Data[i,,],na.rm=T)/puntos.no.na * 100
}

fechitas <- Barcelona_anom$Dates$start[which(porcentual>0)]
meses <- substr(fechitas,6,7)
anios <- substr(fechitas,1,4)

calendario <- seq(from=as.Date("1950-01-1"),to=as.Date("2021-12-31"),by="day")

dias <- list()
for(i in 1:length(anios)){
  dias[[i]] <- calendario[which(substr(calendario,1,4)==anios[i] & substr(calendario,6,7)==meses[i])]  
}
dias_secos <- do.call(c,dias)

############################################
#Composites de anomalías de precipitación (monthly)
subsetGrid(pr_prueba,lonLim = c(0,4),latLim = c(40,43))
comp <- subsetDimension(pr_prueba,dimension = "time",indices=which(porcentual>40))
spatialPlot(climatology(comp),color.theme = "RdBu",rev.colors = F,at=seq(-80,80,by=2),backdrop.theme = "countries")

############################################
